#ifndef H_FWMATOMIC
#define H_FWMATOMIC

#include "utils.h"
#include "layout.h"
#include "wingedmonkey.h"

#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xproto.h>
#include <X11/Xutil.h>


//atoms
enum { NetSupported, NetWMName, NetWMState, NetWMFullscreen,
       NetWMMaximizedVert, NetWMMaximizedHorz, NetWMHidden,
       NetWMSkipTaskbar,
       NetCloseWindow,NetActiveWindow,
       NetDesktopGeometry,NetDesktopViewport,
       NetClientList,NetClientListStacking,
       NetWMAllowedActions, NetWMActionFullscreen,
       NetWMActionMaximizeHorz, NetWMActionMaximizeVert,
       NetWMActionClose, NetWMWindowType,
       NetWMWindowTypeDesktop,
       NetWMWindowTypeDock,
       NetWMWindowTypeToolbar,
       NetWMWindowTypeMenu,
       NetWMWindowTypeUtility,
       NetWMWindowTypeSplash,
       NetWMWindowTypeDialog,
       NetWMWindowTypeNormal,
       NetWMDesktop,NetNumberOfDesktops,NetCurrentDesktop,NetDesktopNames,
       NetSupportingWMCheck,
       NetWMPid,
       NetLast };

enum { WMProtocols, WMDelete, WMState,
       WMName, WMWindowRole, WMClass,
       WMTakeFocus, WMLast };

extern Atom wm_atoms[];
extern Atom net_atoms[];

extern char* wm_strings[WMLast];
extern char* net_strings[NetLast];

long    atomic_getprop_long(Window w, Atom a);
long*   atomic_getprop_longa(Window w, Atom a, int* n);
Window  atomic_getprop_window(Window w, Atom a);
Window* atomic_getprop_windowa(Window w, Atom a, int* n);
Atom    atomic_getprop_atom(Window w, Atom a);
Atom*   atomic_getprop_atoma(Window w, Atom a, int* n);

void    atomic_getstring(Window w, Atom a, char* str);

void    atomic_setprop_long(Window w, Atom a, long data);
void    atomic_setprop_longa(Window w, Atom a, long* data, int n);
void    atomic_setprop_window(Window w, Atom a, Window data);
void    atomic_setprop_windowa(Window w, Atom a, Window* data, int n);
void    atomic_setprop_atom(Window w, Atom a, Atom data);
void    atomic_setprop_atoma(Window w, Atom a, Atom* data, int n);

void    atomic_setstrings(Window w, Atom a, char** str, int count);

void    atomic_sendmsg(Window w, Atom a, Time t);


#endif
